#include <iostream>
#include <algorithm>

using namespace std;

int main()
{
    int T, x;
    cin>>T;
    int X[T];
    for(int i=0;i<T;i++)
    {
        X[i]=1;
        int N, M;
        cin>>N;
        cin>>M;
        long long A[N],B[M];
        for(int j=0;j<N;j++)
        {
            cin>>A[j];
        }
        sort(A, A + N);
        x=A[1]-A[0];
        for(int j=0;j<M;j++)
        {
            cin>>B[j];
        }
        for(int j=0;j<N-1;j++)
        {
            if(B[j]-A[0]>0)
            {
                if((A[j]-A[0])%x!=0)
                {
                    X[i]=0;
                }
                if((B[j]-A[0])%x==0)
                {
                    X[i]=0;
                }
            }
            else
            {
                if((A[0]-B[j])%x==0)
                {
                    X[i]=0;
                }
            }
        }
    }
    for(int i=0;i<T;i++)
    {
        cout<<X[i]<<endl;
    }
    return 0;
}